// Copyright (C) 2003 Daisuke Arai <darai@users.sourceforge.jp>
// 
// This program is part of Protra.
//
// Protra is free software: you can redistribute it and/or modify it
// under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, see <http://www.gnu.org/licenses/>.
// 
// $Id: ExecuterFactoryUnion.cs,v 1.2 2007-12-27 08:34:39 panacoran Exp $

using System;
using System.Collections;

namespace Protra.Lib.Lang.Executer
{
	/// <summary>
	/// 複数のIExecuterFactoryをまとめて1つの
	/// IExecuterFactoryとしてみなすためのクラスです。
	/// </summary>
	public class ExecuterFactoryUnion : IExecuterFactory
	{
		/// <summary>
		/// IExecuterFactoryのリスト
		/// </summary>
		ArrayList factoryList = new ArrayList();

		/// <summary>
		/// コンストラクタ
		/// </summary>
		public ExecuterFactoryUnion() {}

		/// <summary>
		/// IExecuterFactoryを追加します。
		/// </summary>
		/// <param name="factory"></param>
		public void Add(IExecuterFactory factory)
		{
			factoryList.Add(factory);
		}

		/// <summary>
		/// IExecuterを生成します。
		/// </summary>
		/// <exception cref="Protra.Lib.Lang.NoSuchExecuterException">
		/// IExecuterが存在しない場合にthrowされます。
		/// </exception>
		/// <param name="ft">関数のタイプ</param>
		/// <returns>関数を実行するIExcecuterです。</returns>
		public IExecuter CreateExecuter(FunctionType ft)
		{
			foreach(IExecuterFactory factory in factoryList)
			{
				try
				{
					return factory.CreateExecuter(ft);
				}
				catch(NoSuchExecuterException)
				{
				}
			}

			throw new NoSuchExecuterException();
		}
	}
}
